explain_dirfd_or_die(3)

NAME
explain_dirfd_or_die - get directory stream file descriptor and report errors
    "get directory stream file descriptor and report errors"

SYNOPSIS
#include <libexplain/dirfd.h>

int explain_dirfd_or_die(DIR *dir);
int explain_dirfd_on_error(DIR *dir);

DESCRIPTION
The explain_dirfd_or_die function is used to call the dirfd(3) system call. On failure an explanation will be printed to stderr, obtained from the explain_dirfd(3) function, and then the process terminates by calling exit(EXIT_FAILURE).

The explain_dirfd_on_error function is used to call the dirfd(3) system call. On failure an explanation will be printed to stderr, obtained from the explain_dirfd(3) function, but still returns to the caller.

dir The dir, exactly as to be passed to the dirfd(3) system call.

RETURN VALUE
The explain_dirfd_or_die function only returns on success, see dirfd(3) for more information. On failure, prints an explanation and exits, it does not return.

The explain_dirfd_on_error function always returns the value return by the wrapped dirfd(3) system call.

EXAMPLE
The explain_dirfd_or_die function is intended to be used in a fashion similar to the following example:
    int result = explain_dirfd_or_die(dir);

SEE ALSO

dirfd(3)
    get directory stream file descriptor

explain_dirfd(3)
    explain dirfd(3) errors

exit(2)
    terminate the calling process

COPYRIGHT
libexplain version 1.2
Copyright (C) 2009 Peter Miller